//---------------------------------------------------------------------------

#ifndef ExpressionH
#define ExpressionH
#include <vcl.h>
#include "Iterator.h"

//---------------------------------------------------------------------------
class Expression {
  private:
    AnsiString exp;
    virtual bool Match(char c, char d) const;
    virtual int Prioridade(String x) const;
    double x;
    double y;
    double z;
  public:
    Expression (const char * str) ;
    Expression (const Expression& other);
    virtual ~Expression();
    virtual bool Check() const;
   // virtual AnsiString PosFixa();
    virtual bool isSignal(String x);
    virtual bool isFunction(String x);
    virtual String newPosFixa();
    virtual String PutSpace();
    double Calcular();
    double opCalc(double l, String sig, double r) ;

    
    virtual double getX();
    virtual double getY();
    virtual double getZ();

    virtual void setX(double x);
    virtual void setY(double y);
    virtual void setZ(double z);


};
#endif
